VERSION 5.00
Begin VB.Form Form1 
   Caption         =   "Form1"
   ClientHeight    =   2880
   ClientLeft      =   60
   ClientTop       =   345
   ClientWidth     =   3480
   LinkTopic       =   "Form1"
   ScaleHeight     =   2880
   ScaleWidth      =   3480
   StartUpPosition =   3  'Windows Default
   Begin VB.CommandButton cmdSort 
      Caption         =   "Sort"
      Height          =   495
      Left            =   1920
      TabIndex        =   2
      Top             =   2280
      Width           =   1215
   End
   Begin VB.CommandButton cmdRandomize 
      Caption         =   "Randomize"
      Default         =   -1  'True
      Height          =   495
      Left            =   360
      TabIndex        =   1
      Top             =   2280
      Width           =   1215
   End
   Begin VB.Label lblNumbers 
      BorderStyle     =   1  'Fixed Single
      Height          =   2055
      Left            =   120
      TabIndex        =   0
      Top             =   120
      Width           =   3255
   End
End
Attribute VB_Name = "Form1"
Attribute VB_GlobalNameSpace = False
Attribute VB_Creatable = False
Attribute VB_PredeclaredId = True
Attribute VB_Exposed = False
Option Explicit

Private Values() As Integer

Private Const NUM_VALUES = 100

Private Declare Sub CopyMemory Lib "kernel32" Alias "RtlMoveMemory" (Destination As Any, Source As Any, ByVal Length As Long)

' Merge two sorted sublists.
Public Sub Merge(list() As Integer, ByVal beginning As Long, ByVal middle As Long, ByVal ending As Long)
Dim temp_array() As Integer
Dim temp As Integer
Dim counterA As Long
Dim counterB As Long
Dim counterMain As Long

    ' Copy the array into a temporary array.
    ReDim temp_array(beginning To ending)
    CopyMemory temp_array(beginning), list(beginning), (ending - beginning + 1) * Len(list(beginning))

    ' counterA and counterB mark the next item to save
    ' in the first and second halves of the list.
    counterA = beginning
    counterB = middle + 1

    ' counterMain is the index where we will put the
    ' next item in the merged list.
    counterMain = beginning
    Do While (counterA <= middle) And (counterB <= ending)
        ' Find the smaller of the two items at the front
        ' of the two sublists.
        If (temp_array(counterA) <= temp_array(counterB)) Then
            ' The smaller value is in the first half.
            list(counterMain) = temp_array(counterA)
            counterA = counterA + 1
        Else
            ' The smaller value is in the second half.
            list(counterMain) = temp_array(counterB)
            counterB = counterB + 1
        End If
        counterMain = counterMain + 1
    Loop

    ' Copy any remaining items from the first half.
    If counterA <= middle Then
        CopyMemory list(counterMain), temp_array(counterA), (middle - counterA + 1) * Len(list(beginning))
    End If

    ' Copy any remaining items from the second half.
    If counterB <= ending Then
        CopyMemory list(counterMain), temp_array(counterB), (ending - counterB + 1) * Len(list(beginning))
    End If
End Sub
' Sort the list entries with indexes between beginning
' and ending.
Public Sub MergeSort(list() As Integer, ByVal first_index As Long, ByVal last_index As Long)
Dim middle As Long

    If (last_index > first_index) Then
        ' Recursively sort the two halves of the list.
        middle = (first_index + last_index) \ 2
        MergeSort list, first_index, middle
        MergeSort list, middle + 1, last_index

        ' Merge the results.
        Merge list, first_index, middle, last_index
    End If
End Sub

' Generate and display some random numbers
' between 100 and 999.
Private Sub cmdRandomize_Click()
Dim i As Integer
Dim txt As String

    ReDim Values(1 To NUM_VALUES)
    For i = 1 To NUM_VALUES
        Values(i) = Int(Rnd * 899 + 100)
        txt = txt & Format$(Values(i)) & " "
    Next i
    lblNumbers = txt
End Sub

' Sort the numbers.
Private Sub cmdSort_Click()
Dim i As Integer
Dim txt As String

    MergeSort Values, 1, NUM_VALUES

    ' Verify and display the reuslts.
    txt = txt & Format$(Values(1)) & " "
    For i = 2 To NUM_VALUES
        If Values(i) < Values(i - 1) Then Stop
        txt = txt & Format$(Values(i)) & " "
    Next i
    lblNumbers = txt
End Sub

Private Sub Form_Load()
    Randomize
End Sub


